/*****************************************************************************

  %name: nmasmaf.h %
  %version:  8 %
  $Copyright:

  Copyright (c) 1999 - 2007 Novell, Inc.  All Rights Reserved.                      

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.$

 ****************************************************************************/

#ifndef _NMASMAF_H
#define _NMASMAF_H

#include <stddef.h>
#include <nmasclientapi.h>
#include <nmasaid.h>


/*************************************************************************
   NMAS MAF Functionality
*************************************************************************/

#ifndef  MAF_Handle
#define  MAF_Handle  void *
#endif
   
      
NMASAPI int MAF_Begin(
   MAF_Handle mh);

NMASAPI int MAF_Read(
   MAF_Handle mh, 
   size_t *rLenp, 
   void *rBufp);

/* Provides safer way of reading message from queue */
/* Unlike MAF_Read, MAF_ReadV2 requires the length of the buffer to be specified in *rLenp */
NMASAPI int MAF_ReadV2(
   MAF_Handle mh,
   size_t *rLenp,
   void *rBufp);

NMASAPI int MAF_WriteRead(
   MAF_Handle mh, 
   size_t  wLen, 
   void   *wBufp, 
   size_t *wLenp, 
   void   *rBufp);

NMASAPI int MAF_Write(
   MAF_Handle nh, 
   size_t wLen, 
   void  *wBufp);

NMASAPI int MAF_End(
   MAF_Handle mh, 
   int    status, 
   size_t len, 
   void  *seedDatap);

NMASAPI int MAF_XRead(
   MAF_Handle mh, 
   size_t *rLenp, 
   void   *rBufp);

NMASAPI int MAF_XWriteRead(
   MAF_Handle mh, 
   size_t  wLen, 
   void   *wBufp, 
   size_t *wLenp, 
   void   *rBufp);

NMASAPI int MAF_XWrite(
   MAF_Handle nh, 
   size_t wLen, 
   void  *wBufp);

NMASAPI void *MAF_Malloc(
   size_t s);

NMASAPI void *MAF_Realloc(
   void *p, 
   size_t s);

NMASAPI void MAF_Free(
   void *p);

NMASAPI int MAF_GetAttribute(
   MAF_Handle mh, 
   int     aid, 
   void   *uniTag, 
   size_t *aLenInBytesp, 
   void   *aValuep);

NMASAPI int MAF_PutAttribute(
   MAF_Handle mh, 
   int    aid, 
   void  *uniTag, 
   size_t aLenInBytes, 
   void  *aValuep);

NMASAPI void MAF_Trace(
   MAF_Handle mh, 
   const char *message);

NMASAPI void MAF_TraceEx(
   MAF_Handle mh, 
   const char *format, 
   ...);

NMASAPI int MAF_TraceEnabled(
   MAF_Handle mh);

 

#endif
