/******************************************************************************

  Copyright (c) 2006 Novell, Inc.  All Rights Reserved.                      

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

 *****************************************************************************/
 
#ifndef	_METHOD_CB_H
#define	_METHOD_CB_H

// Capability flags that may be returned by the encode and decode routines
#define NMAS_SEC_LAYER_STATUS_INTEG  0x20    // Indicates that message integrity was performed
#define NMAS_SEC_LAYER_STATUS_CONF   0x40    // Indicates that message privacy was performed

typedef int (*SecLayer_EncodeCB_T)(
    void *slHandle,
	nuint32 inFlags,
	nuint32 inBufferSize,
	char *inBuffer,
    nuint32 *outFlags,
	nuint32 *outBufferSize,
	char **outBuffer);
	
typedef int (*SecLayer_DecodeCB_T)(
    void *slHandle,
	nuint32 inFlags,
	nuint32 inBufferSize,
	char *inBuffer,
    nuint32 *outFlags,
	nuint32 *outBufferSize,
	char **outBuffer);

NMASAPI int NMAS_RegisterSecLayerCB(
	nuint32 methodID,
    nuint32 capabilityFlags,
	SecLayer_EncodeCB_T encodeCB,
	SecLayer_DecodeCB_T decodeCB);

NMASAPI int NMAS_UnregisterSecLayerCB(
	nuint32 methodID);


typedef int (*MethodAttributeFreeCB_T)(
    unicode *tag,
    size_t pLen,
    void *p);

NMASAPI int NMAS_RegisterMethodAttrFreeCB(
	nuint32 methodID,
	MethodAttributeFreeCB_T freeCB);

NMASAPI int NMAS_UnregisterMethodAttrFreeCB(
	nuint32 methodID);

#endif
	 
